/* 
 *  $Id: dbg.c,v 1.1 2003/08/11 16:03:13 kogan Exp $
 *
 *  Copyright (c) 2003, Sergey Kogan
 *
 *  This is free software; you can redistribute it and/or modify it under the
 *  terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */

#include <PalmOS.h>
#include <stdarg.h>
#include "resource.h"


void _dbgMsgBox(UInt16 alertId, const Char *msg)
{
	FrmCustomAlert(alertId, msg, " ", " ");
}

void dbgErr(const Char *fmt, Err err, ...)
{
	Char buf[512];
	Char msg[256];
	va_list args;

	va_start(args, err);
	StrVPrintF(buf, fmt, args);
	va_end(args);

    if(err != errNone && SysErrString(err, msg, 255) != NULL)
    {
    	StrCat(buf, ": ");
    	StrCat(buf, msg);
    }
    else
    	StrCat(buf, ".");

	_dbgMsgBox(dbg_error_id, buf);
}

#ifdef DEBUG_BUILD

void dbgMsg(const Char *fmt, ...)
{
	Char buf[512];
	va_list args;

	va_start(args, fmt);
	StrVPrintF(buf, fmt, args);
	va_end(args);

	_dbgMsgBox(dbg_message_id, buf);
}

#endif // ifdef DEBUG_BUILD

void dbgInfo(const Char *fmt, ...)
{
	Char buf[512];
	va_list args;

	va_start(args, fmt);
	StrVPrintF(buf, fmt, args);
	va_end(args);

	_dbgMsgBox(dbg_info_id, buf);
}


