/* 
 *  $Id: format.c,v 1.2 2003/08/13 13:40:26 kogan Exp $
 *
 *  Copyright (c) 2003, Sergey Kogan
 *
 *  This is free software; you can redistribute it and/or modify it under the
 *  terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */

#include <PalmOS.h>
#include "../config.h"
#include "../dia.h"
#include "../dbg.h"

/*** protocol specific formatting functions implementation ***/

#define DEG "\260"	// degree symbol

// E
DIA_DEFINE_FMT(gmvzSPD)
{
	return StrPrintF(fmt, "%ukm/h", UINT16(*data));
}

// E/2.55
DIA_DEFINE_FMT(gmvzTPS)
{
	UInt32 v = UINT32(*data) * 25700L;
	return StrPrintF(fmt, "%ld%%", v >> 16);
}

// 3932160 / E
DIA_DEFINE_FMT(gmvzRPM)
{
	UInt16 v = ( ((UINT16(*data)<<8|UINT16(*(data+1))) == 0) ? 0 : ( UINT16(3932160L/UINT32(UINT16(*data)<<8|UINT16(*(data+1)))) ) );
	return StrPrintF(fmt, "%urpm", v);
}

DIA_DEFINE_SCALE(gmvzRPM)
{
	UInt32 v = (((UINT16(*data)<<8|UINT16(*(data+1))) == 0) ? 0L : UINT32(3932160L/UINT32(UINT16(*data)<<8|UINT16(*(data+1)))));
	return vsize - 1 - UINT8(v*UINT32(vsize)/9000L);
}

DIA_DEFINE_SCALE(gmvzTPS)
{
	return vsize - 1 - UINT8((UINT16(*data)*vsize)/255);
}

