/* 
 *  $Id: gmvz.h,v 1.2 2003/11/26 15:54:15 kogan Exp $
 *
 *  Copyright (c) 2003, Sergey Kogan
 *
 *  This is free software; you can redistribute it and/or modify it under the
 *  terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */

#ifndef GMVZ_H
#define GMVZ_H

#define GMVZ_SECT __attribute__ ((section ("gmvz")))

DiaReturnType GmvzStart(UInt32 mask) GMVZ_SECT;
DiaReturnType GmvzStop() GMVZ_SECT;

/* call this function as frequently as possible */
DiaReturnType GmvzRun() GMVZ_SECT;

/* driver states */
Boolean GmvzIsRunning() GMVZ_SECT;
Boolean GmvzIsConnected() GMVZ_SECT;
Boolean GmvzIsPolling() GMVZ_SECT;
Char* GmvzGetLastError() GMVZ_SECT; /* return NULL if no errors */

/* polling */
DiaReturnType GmvzStartSensorsPoll() GMVZ_SECT;
DiaReturnType GmvzStopSensorsPoll() GMVZ_SECT;
DiaSampleType* GmvzGetSample() GMVZ_SECT; /* return NULL if sample is not ready, flush sample */

/* operations */
DiaReturnType GmvzCtl(UInt8 ctl, void *param) GMVZ_SECT;
Boolean GmvzCtlGetResult(UInt8 *ctl, void **param, UInt16 *size) GMVZ_SECT; /* return FALSE if result is not ready */

void GmvzPrefsDialog() GMVZ_SECT;
void GmvzAboutDialog() GMVZ_SECT;
void GmvzLoadPrefs(DiaPrefsType *prefs) GMVZ_SECT;
void GmvzSavePrefs(DiaPrefsType *prefs) GMVZ_SECT;

//extern UInt32 _gmvzMaxP1;
//extern UInt32 _gmvzMaxP2;
//extern UInt32 _gmvzMinP3;

extern const DiaSensorType gmvzSensorDefault[];
extern const DiaTimingType gmvzTimingDefault;
extern DiaTimingType gmvzTiming;
extern DiaCtlType gmvzctl[];

#endif