/* 
 *  $Id: kwp2.h,v 1.2 2003/11/26 15:54:15 kogan Exp $
 *
 *  Copyright (c) 2003, Sergey Kogan
 *
 *  This is free software; you can redistribute it and/or modify it under the
 *  terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */

#ifndef KWP2_H
#define KWP2_H

#define KWP2_SECT __attribute__ ((section ("kwp2")))

DiaReturnType Kwp2Start(UInt32 mask) KWP2_SECT;
DiaReturnType Kwp2Stop() KWP2_SECT;

/* call this function as frequently as possible */
DiaReturnType Kwp2Run() KWP2_SECT;

/* driver states */
Boolean Kwp2IsRunning() KWP2_SECT;
Boolean Kwp2IsConnected() KWP2_SECT;
Boolean Kwp2IsPolling() KWP2_SECT;
Char* Kwp2GetLastError() KWP2_SECT; /* return NULL if no errors */

/* polling */
DiaReturnType Kwp2SetMask(UInt32 mask) KWP2_SECT;
DiaReturnType Kwp2StartSensorsPoll() KWP2_SECT;
DiaReturnType Kwp2StopSensorsPoll() KWP2_SECT;
DiaSampleType* Kwp2GetSample() KWP2_SECT; /* return NULL if sample is not ready, flush sample */

/* operations */
DiaReturnType Kwp2Ctl(UInt8 ctl, void *param) KWP2_SECT;
Boolean Kwp2CtlGetResult(UInt8 *ctl, void **param, UInt16 *size) KWP2_SECT; /* return FALSE if result is not ready */

void Kwp2PrefsDialog() KWP2_SECT;
void Kwp2AboutDialog() KWP2_SECT;
void Kwp2LoadPrefs(DiaPrefsType *prefs) KWP2_SECT;
void Kwp2SavePrefs(DiaPrefsType *prefs) KWP2_SECT;

extern const DiaSensorType kwp2SensorDefault[];
extern const DiaTimingType kwp2TimingDefault;
extern DiaTimingType kwp2Timing;
extern DiaCtlType kwp2ctl[];

#endif
