/* 
 *  $Id: mp7.h,v 1.1 2003/11/26 15:53:26 kogan Exp $
 *
 *  Copyright (c) 2003, Sergey Kogan
 *
 *  This is free software; you can redistribute it and/or modify it under the
 *  terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */

#ifndef MP7_H
#define MP7_H

#define MP7_SECT __attribute__ ((section ("kwp2")))

DiaReturnType	Mp7Start(UInt32 mask) MP7_SECT;
DiaReturnType	Mp7Stop() MP7_SECT;

/* call this function as frequently as possible */
DiaReturnType	Mp7Run() MP7_SECT;

/* driver states */
Boolean		Mp7IsRunning() MP7_SECT;
Boolean		Mp7IsConnected() MP7_SECT;
Boolean		Mp7IsPolling() MP7_SECT;
Char*		Mp7GetLastError() MP7_SECT; /* return NULL if no errors */

/* polling */
DiaReturnType	Mp7StartSensorsPoll() MP7_SECT;
DiaReturnType	Mp7StopSensorsPoll() MP7_SECT;
DiaSampleType*	Mp7GetSample() MP7_SECT; /* return NULL if sample is not ready, flush sample */

/* operations */
DiaReturnType	Mp7Ctl(UInt8 ctl, void *param) MP7_SECT;
Boolean		Mp7CtlGetResult(UInt8 *ctl, void **param, UInt16 *size) MP7_SECT; /* return FALSE if result is not ready */

void		Mp7PrefsDialog() MP7_SECT;
void		Mp7AboutDialog() MP7_SECT;
void		Mp7LoadPrefs(DiaPrefsType *prefs) MP7_SECT;
void		Mp7SavePrefs(DiaPrefsType *prefs) MP7_SECT;

DiaReturnType	_Mp7Error(Char *msg, Err err, Boolean fatal) MP7_SECT; // always return DIA_ERROR
DiaReturnType	_Mp7SendAsync(UInt8 *req, UInt8 size, UInt8 recv_to) MP7_SECT;

DIA_DEFINE_CTL(Mp7EcuReset	) MP7_SECT;
DIA_DEFINE_CTL(Mp7ReadIdent	) MP7_SECT;
DIA_DEFINE_CTL(Mp7ClearErrors	) MP7_SECT;
DIA_DEFINE_CTL(Mp7ReadErrors	) MP7_SECT;
DIA_DEFINE_CTL(Mp7Connect	) MP7_SECT;
DIA_DEFINE_CTL(Mp7Disconnect	) MP7_SECT;
DIA_DEFINE_CTL(Mp7Ping		) MP7_SECT;
DIA_DEFINE_CTL(Mp7Reconnect	) MP7_SECT;
DIA_DEFINE_CTL(Mp7SetTiming	) MP7_SECT;

typedef enum _Mp7WaitingFor {
	DIA_WAIT_NONE,
	DIA_WAIT_SEND,
	DIA_WAIT_ECHO,
	DIA_WAIT_HDR,
	DIA_WAIT_REPLY
} Mp7WaitingFor;

typedef struct _Mp7RequestType {
	UInt8	ctl;		// parameters passed to Mp72Ctl()
	void*	ctl_param;			
	
	UInt8	send[256];
	UInt8	send_size;
	UInt32	send_ticks;

	UInt32	sample;		// sample start point
	UInt32	res0;		// reserved
	UInt8	recv[256];
	UInt8	recv_size;
	UInt8	recv_checksum;
	UInt8	recv_to;

	UInt8	retry;		// retries counter
} Mp7RequestType;

extern Mp7RequestType	_mp7Req;
extern DiaSampleType*	_mp7SampleP;
extern Boolean		_mp7SampleReady;

#endif
